;
;	Sudoku megfejt
;
;
;


	.org 0100h			; a VT-DOS programok betltsi cme


pmain:	ld	hl,(0006h)		; TPA terlet fels hatrnak meghatrozsa
	ld	de,00010h		; 16 bjtnyi rs meghagysa
	sbc	hl,de
	ld	sp,hl			; sajt veremterlet kialaktsa a TPA terlet tetejn
;
	ld	hl,introtxt		; ismertet kirsa
	call	ut_prnt
	ld	hl,grigliainiziale
	call	getcons			; kezdeti rcs bekrse a konzolrl
	ld	bc,81			; kezd szmok tmsolsa a vgeredmny tblzatba
	ld	hl,grigliainiziale
	ld	de,grigliafinale
	ldir
	ld	hl,starttxt		; kezdeti llapot megjelentse a kpernyn
	call	ut_prnt
	ld	hl,grigliainiziale
	call	stampa
	call	ut_lnf
;
	call	prova			; megfejts, eredmny kirsa

;
exit:	jp	0000h			; vissza a VT-DOS-ba


;
;	Rekurzis megfejt rutin
;	in:  ?A - a rcsban htralv szmok (81..0)
;	out: CY - CY=0 -> sikertelen  CY=1 -> sikeres
;
prova:	ld	hl,grigliafinale
	ld	bc,0009h		; BC= egy sorban lv szmok mennyisge
	ld	d,b			; D= aktulis sor (0)
	ld	e,c			; E= ellenrzend sorok szma
	xor	a			; A= 0 -> az els res helyet keresi majd
prova0:	cpir
	jr	z,prova1		; ugrs, ha tallt res helyet
	inc	d			; sor szmnak nvels
	ld	c,009h			; BC= 9
	dec	e
	jr	nz,prova0		; ismtls az sszes sorra
	ld	hl,endtxt		; eredmny megjelentse a kpernyn
	call	ut_prnt
	ld	hl,grigliainiziale
	ld	de,grigliafinale
	call	stampa2
	scf				; CY=1 -> sikeres megfejts
	ret
;
prova1:	ld	a,008h
	sub	c
	ld	e,a			; E= oszlop
	push	hl
	ld	hl,row_table
	ld	c,d			; BC= aktulis sor
	add	hl,bc
	ld	a,(hl)			; A reg.= (sor mod 3) * 9
	ld	hl,col_table
	ld	c,e			; BC= aktulis oszlop
	add	hl,bc
	add	a,(hl)
	ld	c,a			; C= blokk bal fels elemnek relatv cme
	pop	hl
	ld	a,d
	add	a,a
	add	a,a
	add	a,a
	add	a,d
	ld	d,a			; D= sor * 9
	dec	hl			; HL= mtrix elem cme
	ld	b,1			; B= a vizsgland szm az adott pozciban
prova2:	ld	(hl),b			; vizsgland szm bersa a rcsba
	push	hl
	push	de
	push	bc
	call	valido_fast		; szm helyesgnek ellenrzse
	call	c,prova			; ha j, akkor jhet a kvetkez res pozci
	pop	bc
	pop	de
	pop	hl
	ret	c			; visszatrs, ha sikeres a htralv pozcik megfejtse
	inc	b			; berand szm nvelse
	ld	a,b
	cp	10
	jr	nz,prova2		; ismtls, amg a prbland szm kisebb 10-nl
	ld	(hl),000h		; egybknt a bert szm trlse
	or	a			; CY=0 -> sikertelen
	ret


;
;	Gyorsellenrz rutin
;	in:   C - blokk bal fels elemnek relatv cme
;	      D - mtrix sor * 9
;	      E - mtrix oszlop
;	out: CY - CY=0 -> sikertelen  CY=1 -> sikeres
;
valido_fast:
	ld	a,c			; kezdeti belltsok
	exx
	ld	b,000h			; B'= 0
	ld	c,a			; C'= blokk bal fels elemnek relatv cme
	ld	de,test_array-1		; DE' a teszt tmb eleje-1 -re mutat
	exx
	ld	b,9
	ld	hl,test_array
vfast0:	ld	(hl),001h		; teszt tmb inicializlsa
	inc	hl
	djnz	vfast0
	ld	c,d			; BC= ellenrzend mtrix sor * 9
	ld	hl,grigliafinale
	add	hl,bc			; HL a sor elejre mutat
	ld	b,9			; 9 szm van egy sorban
vfast1:	ld	a,(hl)			; A= a mtrix aktulis eleme
	inc	hl
	or	a
	jr	z,vfast2		; ugrs, ha egy res elem
	exx
	ld	l,a
	ld	h,b
	add	hl,de			; HL' a teszt tmb adott elemre mutat (CY=0)
	dec	(hl)			; szm elfordulsi szmllja
	exx
	ret	nz			; visszatrs, ha egy szm tbbszr elfordul a sorban, CY=0
vfast2:	djnz	vfast1
;
	ld	b,9
	ld	hl,test_array
vfast3:	ld	(hl),001h		; teszt tmb inicializlsa
	inc	hl
	djnz	vfast3
	ld	c,e			; BC= ellenrzend mtrix oszlop
	ld	hl,grigliafinale
	add	hl,bc			; HL az oszlop tetejre mutat
	ld	de,0009h		; DE= rtk az oszlop kvetkez sorhoz
	ld	b,9			; 9 szm van egy oszlopban
vfast4:	ld	a,(hl)			; A= a mtrix aktulis eleme
	add	hl,de
	or	a
	jr	z,vfast5		; ugrs, ha egy res elem
	exx
	ld	l,a
	ld	h,b
	add	hl,de			; HL' a teszt tmb adott elemre mutat (CY=0)
	dec	(hl)			; szm elfordulsi szmllja
	exx
	ret	nz			; visszatrs, ha egy szm tbbszr elfordul a sorban, CY=0
vfast5:	djnz	vfast4
;
	ld	b,9
	ld	hl,test_array
vfast6:	ld	(hl),001h		; teszt tmb inicializlsa
	inc	hl
	djnz	vfast6
	exx
	ld	a,c
	exx
	ld	c,a			; BC= blokk bal fels elemnek relatv cme
	ld	hl,grigliafinale
	add	hl,bc			; HL a blokk bal fels elemre mutat
	ld	de,0006h		; DE= rtk a blokk kvetkez sorhoz
	ld	c,3			; 3 sor van egy blokk oszlopban
vfast7:	ld	b,3			; 3 szm van egy blokk sorban
vfast8:	ld	a,(hl)			; A= a mtrix aktulis eleme
	inc	hl
	or	a
	jr	z,vfast9		; ugrs, ha egy res elem
	exx
	ld	l,a
	ld	h,b
	add	hl,de			; HL' a teszt tmb adott elemre mutat (CY=0)
	dec	(hl)			; szm elfordulsi szmllja
	exx
	ret	nz			; visszatrs, ha egy szm tbbszr elfordul a blokkban, CY=0
vfast9:	djnz	vfast8
	add	hl,de
	dec	c
	jr	nz,vfast7		; ismtls a blokk sszes sorra
	scf				; CY=1 -> sikeres
	ret


;
;	Kezdeti ismert szmok bekrse
;	in:  HL - rcs kezdcme
;	out: -
;
getcons:ld	b,009h			; 9 sor lesz
getcn0:	push	bc
	push	hl
	ld	de,puffer		; ide olvassa a begpelt karaktereket
	ld	a,009h
	ld	(de),a			; a puffer els bjtjra a beolvasand hossz (9)
	ld	c,00Ah			; funkcikd: pufferelt sor input
	call	0005h			; VT-DOS hvsa
	call	ut_lnf			; soremels a konzolon
	pop	hl
	ld	b,009h			; 9 karaktert ellenriz
	ld	de,puffer+2
getcn1:	ld	a,(de)
	inc	de
	sub	030h			; ASCII kd tkonvertlsa 0-9 szmm
	cp	00Ah
	jr	c,getcn2		; ugrs, ha 0-9 tartomnyba esik
	xor	a			; egybknt szm = 0
getcn2:	ld	(hl),a			; trols a rcsban
	inc	hl
	djnz	getcn1			; ismtls a sorban lv sszes karakterre
	pop	bc
	djnz	getcn0			; ismtls az sszes sorra
	ret


;
;	Kezdeti rcs kirajzolsa
;	in:  HL - rcs kezdcme
;	out: -
;
stampa:	ld	b,003h			; 3 sor lesz
stampa0:push	bc
	push	hl			; egy sor kirsa
	ld	hl,racstxt
	call	ut_prnt
	pop	hl
	call	prline
	call	ut_lnf
	call	prline
	call	ut_lnf
	call	prline
	call	ut_lnf
	pop	bc
	djnz	stampa0
	ld	hl,racstxt		; zr rcs-vonal
	call	ut_prnt
	ret


;
;	Kezdeti s megfejtett rcs kirajzolsa egyms mell
;	in:  HL - kezd rcs cme
;	     DE - megfejtett rcs cme
;	out: -
;
stampa2:ld	c,003h			; 3 fsor lesz
stmpa20:ld	b,003h			; 3 bels sor lesz
	scf				; CY=1 -> rcsvonallal kezd
stmpa21:push	bc
	push	de
	push	hl
	ld	hl,racs2txt		; egy sor kirsa
	call	c,ut_prnt
	pop	hl
	call	prline			; kezd rcs szmai
	push	hl
	ld	hl,rspace
	call	ut_prnt			; rcsok kztt helykzk
	pop	hl
	ex	(sp),hl
	call	prline			; eredmny rcs szmai
	ex	(sp),hl
	call	ut_lnf
	pop	de
	pop	bc
	or	a			; CY=0 -> nem lesz rcsvonal hzva
	djnz	stmpa21
	dec	c
	jr	nz,stmpa20
	ld	hl,racs2txt		; zr rcs-vonal
	call	ut_prnt
	ret


;
;	Egy sor szmainak kirsa
;	in:  HL - sor kezdcme
;	out: HL - a kvetkez sor elejre mutat
;
prline:	push	hl
	ld	e,'!'
	ld	c,002h			; funkcikd: konzol output
	call	0005h			; VT-DOS hvsa
	pop	hl
	ld	bc,0303h		; 3x3 (9) szm van egy sorban
prline0:push	bc
	ld	a,(hl)
	inc	hl
	ld	e,020h			; SPACE-t r ki, ha 0 lenne a szm
	or	a
	jr	z,prline1
	add	a,030h
	ld	e,a
prline1:push	hl
	ld	c,002h			; funkcikd: konzol output
	call	0005h			; VT-DOS hvsa
	pop	hl
	pop	bc
	djnz	prline0
	push	bc
	push	hl
	ld	e,'!'
	ld	c,002h			; funkcikd: konzol output
	call	0005h			; VT-DOS hvsa
	pop	hl
	pop	bc
	ld	b,003h
	dec	c
	jr	nz,prline0		; ismtls 3 blokkra
	ret


;
;	Soremels a kpernyn
;
ut_lnf:	push	hl			; HL mentse a MOPS kompatibilitshoz
	ld	e,00Dh			; '\r'
	ld	c,002h			; funkcikd: konzol output
	call	0005h			; VT-DOS hvsa
	ld	e,00Ah			; '\n'
	ld	c,002h			; funkcikd: konzol output
	call	0005h			; VT-DOS hvsa
	pop	hl
	ret


;
;	Szveg kirsa az aktulis karakteres pozciba
;	in:  HL - 0-val lezrt string kezdete
;	out: HL - a lezr nulla utni cm
;
ut_prnt:ld	a,(hl)
	inc	hl
	or	a
	ret	z
	push	hl			; string aktulis cmnek mentse
	ld	e,a			; E= karakterkd
	ld	c,002h			; C= funkcikd: konzol output
	call	0005h			; VT-DOS hvsa
	pop	hl			; string cm vissza
	jr	ut_prnt


introtxt
	.text	"SUDOKU\r\n\r\n"
	.text	"\202rd be az ismert sz\220mokat 9x9-es elrendez\221sben,\r\n"
	.text	"az \227res helyekre 0 ker\227lj\224n, a sor v\221g\221n RETURN!\r\n"
	.text	"\r\n\000"

starttxt
	.text	"\r\n"
	.text	"Starting grid\r\n"
	.text	"-------------\r\n"
	.text	"\r\n\000"

racs2txt
	.text	"+---+---+---+   "
racstxt	.text	"+---+---+---+\r\n\000"
rspace	.text	"   \000"

endtxt
	.text	"A solution has been found:\r\n"
	.text	"==========================\r\n"
	.text	"\r\n\000"

row_table
	.db	0,0,0,27,27,27,54,54,54

col_table
	.db	0,0,0,3,3,3,6,6,6

test_array
	.db	0,0,0,0,0,0,0,0,0,0

grigliainiziale
	.db	0,0,0,9,0,0,0,0,8
	.db	0,0,0,2,0,3,0,7,5
	.db	0,0,3,0,0,0,0,0,0
	.db	0,0,0,0,0,0,5,0,0
	.db	0,0,7,0,3,0,1,0,0
	.db	3,1,8,0,0,0,0,2,0
	.db	0,0,6,0,5,8,4,0,0
	.db	7,0,0,0,4,0,0,0,0
	.db	2,0,5,0,0,9,0,0,0

grigliafinale
	.db	0,0,0,0,0,0,0,0,0
	.db	0,0,0,0,0,0,0,0,0
	.db	0,0,0,0,0,0,0,0,0
	.db	0,0,0,0,0,0,5,0,0
	.db	0,0,7,0,3,0,1,0,0
	.db	3,1,8,0,0,0,0,2,0
	.db	0,0,6,0,5,8,4,0,0
	.db	7,0,0,0,4,0,0,0,0
	.db	2,0,5,0,0,9,0,0,0

puffer	.equ	$

.end

